#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SquamaExchangeCFG.h"
std::auto_ptr<Fish_SquamaExchangeCFG> Fish_SquamaExchangeCFG::msSingleton(nullptr);

int Fish_SquamaExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SquamaExchangeCFGData* Fish_SquamaExchangeCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SquamaExchangeCFGData>& Fish_SquamaExchangeCFG::GetMapData()
{
	return mMapData;
}

void Fish_SquamaExchangeCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SquamaExchangeCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SquamaExchangeCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mPrice = element->IntAttribute("Price");
		{
			const char* DiscountGift = element->Attribute("DiscountGift");
			std::vector<std::string> vecDiscountGift;
			boost::split(vecDiscountGift, DiscountGift, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDiscountGift.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDiscountGift[i].c_str(), &temp))
				{
					data.mDiscountGift.push_back(temp);
				}
			}
		}
		{
			const char* SalePrice = element->Attribute("SalePrice");
			std::vector<std::string> vecSalePrice;
			boost::split(vecSalePrice, SalePrice, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecSalePrice.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecSalePrice[i].c_str(), &temp))
				{
					data.mSalePrice.push_back(temp);
				}
			}
		}
		data.mFinalPrice = element->IntAttribute("FinalPrice");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		{
			const char* Rate = element->Attribute("Rate");
			std::vector<std::string> vecRate;
			boost::split(vecRate, Rate, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRate.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRate[i].c_str(), &temp))
				{
					data.mRate.push_back(temp);
				}
			}
		}
		data.mGoldIcon = element->Attribute("GoldIcon");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SquamaExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SquamaExchangeCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SquamaExchangeCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SquamaExchangeCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SquamaExchangeCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Price", data.mPrice);
		LuaCfgHelper::readVectorInt(L, "DiscountGift", data.mDiscountGift);
		LuaCfgHelper::readVectorInt(L, "SalePrice", data.mSalePrice);
		LuaCfgHelper::readInt(L, "FinalPrice", data.mFinalPrice);
		LuaCfgHelper::readVectorInt(L, "RewardList", data.mRewardList);
		LuaCfgHelper::readVectorInt(L, "RewardCount", data.mRewardCount);
		LuaCfgHelper::readVectorInt(L, "Rate", data.mRate);
		LuaCfgHelper::readString(L, "GoldIcon", data.mGoldIcon);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SquamaExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SquamaExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SquamaExchangeCFG* Fish_SquamaExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SquamaExchangeCFG());
	}
	return msSingleton.get();
}

void Fish_SquamaExchangeCFG::Release()
{
	msSingleton.reset(nullptr);
}
